"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BitPadding = void 0;
class BitPadding {
    addPadding(data, blockSize) {
        const paddingLength = blockSize - data.length % blockSize;
        return new Uint8Array([...data, 1, ...new Array(paddingLength - 1).fill(0)]);
    }
    removePadding(data) {
        let index = data.length - 1;
        while (data[index] !== 1)
            index -= 1;
        return data.slice(0, index);
    }
}
exports.BitPadding = BitPadding;
