"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ISO10126Padding = void 0;
const crypto_1 = require("crypto");
class ISO10126Padding {
    addPadding(data, blockSize) {
        const paddingLength = blockSize - data.length % blockSize;
        return new Uint8Array([...data, ...(0, crypto_1.randomBytes)(paddingLength - 1), paddingLength]);
    }
    removePadding(data) {
        const paddingLength = data[data.length - 1];
        return data.slice(0, data.length - paddingLength);
    }
}
exports.ISO10126Padding = ISO10126Padding;
