import type { Firestore } from 'firebase-admin/firestore';
import { FirestoreDocument } from './FirestoreDocument';
import type { FirestorePath } from './FirestorePath';
export declare class FirestoreCollection<Documents extends Record<string, FirestoreDocument<any, any>>> {
    private readonly firestore;
    private readonly path;
    constructor(firestore: Firestore, path: FirestorePath);
    document<Key extends keyof Documents & string>(key: Key): Documents[Key];
}
export declare namespace FirestoreCollection {
    type DocumentsOf<Collection extends FirestoreCollection<any>> = Collection extends FirestoreCollection<infer Documents> ? Documents : never;
}
