"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FirebaseAuthenticator = void 0;
const auth_1 = require("firebase/auth");
class FirebaseAuthenticator {
    options;
    authInstance;
    constructor(options, authInstance) {
        this.options = options;
        this.authInstance = authInstance;
    }
    async signIn(email, password) {
        try {
            return await (0, auth_1.createUserWithEmailAndPassword)(this.authInstance, email, password);
        }
        catch {
            return await (0, auth_1.signInWithEmailAndPassword)(this.authInstance, email, password);
        }
    }
    async signOut() {
        await (0, auth_1.signOut)(this.authInstance);
    }
}
exports.FirebaseAuthenticator = FirebaseAuthenticator;
